=== debian/changelog ===
feather-wallet (2.8.1+dfsg-3~bpo13+1) trixie-backports; urgency=medium

  * Rebuild for trixie-backports.

 -- Soren Stoutner <soren@debian.org>  Tue, 20 Jan 2026 17:12:34 -0700

feather-wallet (2.8.1+dfsg-1~bpo13+1) trixie-backports; urgency=medium

  * Rebuild for trixie-backports.

 -- Soren Stoutner <soren@debian.org>  Tue, 18 Nov 2025 09:07:52 -0700
