=== debian/control ===
Source: feather-wallet
Maintainer: Debian Cryptocoin Team <team+cryptocoin@tracker.debian.org>
Uploaders: Soren Stoutner <soren@debian.org>,
Section: utils
Build-Depends: cmake,
               debhelper-compat (= 13),
               dh-sequence-builtusing,
               doxygen,
               graphviz,
               libbc-ur-dev,
               libboost-chrono-dev,
               libboost-filesystem-dev,
               libboost-program-options-dev,
               libboost-regex-dev,
               libboost-serialization-dev,
               libboost-thread-dev,
               libhidapi-dev,
               libreadline-dev,
               libpolyseed-dev,
               libprotobuf-dev,
               libqrencode-dev,
               libsodium-dev,
               libssl-dev,
               libunbound-dev,
               libusb-1.0-0-dev,
               libxkbcommon-dev,
               libzxing-dev,
               pkgconf,
               protobuf-compiler,
               qt6-base-dev,
               qt6-multimedia-dev,
               qt6-svg-dev,
               qt6-wayland-dev,
               qt6-websockets-dev,
               rapidjson-dev
Homepage: https://featherwallet.org/
Vcs-Git: https://salsa.debian.org/cryptocoin-team/feather-wallet.git
Vcs-Browser: https://salsa.debian.org/cryptocoin-team/feather-wallet
Standards-Version: 4.7.3

Package: feather-wallet
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: tor
Suggests: i2pd,
          trezor,
          xmrig
Built-Using: ${dh-builtusing:libbc-ur-dev}
Description: Light-weight Monero GUI desktop wallet
 Feather is a Monero desktop wallet written in C++ with the Qt framework. As
 contrasted with a typical Monero wallet, Feather does not need to have a copy
 of the entire Monero blockchain installed locally, which requires a lot of
 space, but rather connects to an on-line node of servers and queries their copy
 of the blockchain. This makes Feather small and fast. Feather is beginner
 friendly, but also caters to advanced Monero users by providing a feature set
 that is on par with the official CLI. It ships with sane defaults that suit
 most users, but can also be configured for high or uncommon threat models.
 .
 Monero (XMR) is an open-source cryptocurrency that focuses on privacy and
 decentralization. It aims to improve on existing cryptocurrency design
 by obscuring sender, recipient and amount of every transaction.
